
%if 0%{?rhel} == 7
%bcond_with    python3
%bcond_without python2
%else
%bcond_with    python2
%bcond_without python3
%endif

%global library tinyrpc
%global module tinyrpc

Name:       python-%{library}
Version:    0.9.1
Release:    4%{?dist}
Summary:    A modular RPC library
License:    MIT
URL:        https://github.com/mbr/%{library}

Source0:    https://github.com/mbr/%{library}/archive/%{version}.tar.gz

BuildArch:  noarch

%description
tinyrpc is a library for making and handling RPC calls in python.

%if %{with python2}
%package -n python2-%{library}
Summary:    A modular RPC library
%{?python_provide:%python_provide python2-%{library}}

BuildRequires:  python2-devel
BuildRequires:  python2-setuptools
BuildRequires:  git
BuildRequires:  python2-funcsigs
BuildRequires:  python2-gevent
BuildRequires:  python2-greenlet
BuildRequires:  python2-mock
BuildRequires:  python2-py
BuildRequires:  python2-pytest
BuildRequires:  python2-requests
BuildRequires:  python2-six
BuildRequires:  python2-sphinx
%if 0%{?fedora} || 0%{?rhel} > 7
BuildRequires:  python2-werkzeug
BuildRequires:  python2-zmq
%else
BuildRequires:  python-werkzeug
BuildRequires:  python-zmq
%endif

Requires:  python2-funcsigs
Requires:  python2-gevent
Requires:  python2-greenlet
Requires:  python2-requests
Requires:  python2-six
%if 0%{?fedora} || 0%{?rhel} > 7
Requires:  python2-werkzeug
Requires:  python2-zmq
%else
Requires:  python-werkzeug
Requires:  python-zmq
%endif

%description -n python2-%{library}
tinyrpc is a library for making and handling RPC calls in python. 


%package -n python2-%{library}-tests
Summary:    Tests for python2-tinyrpc library

Requires:  python2-funcsigs
Requires:  python2-gevent
Requires:  python2-greenlet
Requires:  python2-mock
Requires:  python2-py
Requires:  python2-pytest
Requires:  python2-requests
Requires:  python2-six
Requires:  python2-werkzeug
Requires:  python2-zmq
Requires:  python2-%{library} = %{version}-%{release}


%description -n python2-%{library}-tests
Tests for  python2-tinyrpc library
%endif

%package -n python-%{library}-doc
Summary:   Documentation for tinyrpc library

%description -n python-%{library}-doc
Documentation for tinyrpc library

%if 0%{?with_python3}
%package -n python3-%{library}
Summary:    A modular RPC library
%{?python_provide:%python_provide python3-%{library}}

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-funcsigs
BuildRequires:  python3-gevent
BuildRequires:  python3-greenlet
BuildRequires:  python3-mock
BuildRequires:  python3-py
BuildRequires:  python3-pytest
BuildRequires:  python3-requests
BuildRequires:  python3-six
BuildRequires:  python3-sphinx
BuildRequires:  python3-werkzeug
BuildRequires:  python3-zmq

Requires:  python3-funcsigs
Requires:  python3-gevent
Requires:  python3-greenlet
Requires:  python3-requests
Requires:  python3-six
Requires:  python3-werkzeug
Requires:  python3-zmq


%description -n python3-%{library}
tinyrpc is a library for making and handling RPC calls in python.

%package -n python3-%{library}-tests
Summary:    Tests for python2-tinyrpc library

Requires:  python3-funcsigs
Requires:  python3-gevent
Requires:  python3-greenlet
Requires:  python3-mock
Requires:  python3-py
Requires:  python3-pytest
Requires:  python3-requests
Requires:  python3-six
Requires:  python3-werkzeug
Requires:  python3-zmq
Requires:  python3-%{library} = %{version}-%{release}

%description -n python3-%{library}-tests
Tests for  python2-tinyrpc library

%endif # with_python3

%prep
%autosetup -n %{library}-%{version} -S git

%build
%if %{with python2}
%py2_build
%endif
%if 0%{?with_python3}
%py3_build
%endif

# generate html docs
%if %{with python2}
%{__python2} setup.py build_sphinx
%else
%{__python3} setup.py build_sphinx
%endif
# remove the sphinx-build leftovers
rm -rf build/sphinx/html/.{doctrees,buildinfo}

%install
%if %{with python2}
%py2_install
# Copy tests
mkdir -p %{buildroot}%%{python2_sitelib}/%{library}/tests
cp -r tests %{buildroot}%{python2_sitelib}/%{library}/tests
%endif
%if 0%{?with_python3}
%py3_install
# Copy tests
mkdir -p %{buildroot}%%{python3_sitelib}/%{library}/tests
cp -r tests %{buildroot}%{python3_sitelib}/%{library}/tests
%endif

%check
export PYTHONPATH=.
%if %{with python2}
py.test -rs --ignore=tests/test_wsgi_transport.py
%endif
%if 0%{?with_python3}
py.test-3 -rs --ignore=tests/test_wsgi_transport.py
%endif

%if %{with python2}
%files -n python2-%{library}
%license LICENSE
%{python2_sitelib}/%{module}
%{python2_sitelib}/%{module}-*.egg-info
%exclude %{python2_sitelib}/%{module}/tests

%files -n python2-%{library}-tests
%license LICENSE
%{python2_sitelib}/%{module}/tests
%endif

%files -n python-%{library}-doc
%license LICENSE
%doc build/sphinx/html README.rst

%if 0%{?with_python3}
%files -n python3-%{library}
%license LICENSE
%{python3_sitelib}/%{module}
%{python3_sitelib}/%{module}-*.egg-info
%exclude %{python3_sitelib}/%{module}/tests

%files -n python3-%{library}-tests
%license LICENSE
%{python3_sitelib}/%{module}/tests
%endif # with_python3

%changelog
* Mon Oct 29 2018 Alfredo Moralejo <amoralej@redhat.com> - 0.9.1-4
- Remove python2 subpackages from Fedora.

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Jun 19 2018 Miro Hrončok <mhroncok@redhat.com> - 0.9.1-2
- Rebuilt for Python 3.7

* Wed Jun 06 2018 Alfredo Moralejo <amoralej@redhat.com> - 0.9.1-1
- Update to upstream version 0.9.1.

* Fri Feb 09 2018 Iryna Shcherbina <ishcherb@redhat.com> - 0.5-7.20170523git1f38ac
- Update Python 2 dependency declarations to new packaging standards
  (See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3)

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.5-6.20170523git1f38ac
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.5-5.20170523git1f38ac
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 15 2017 Lumír Balhar <lbalhar@redhat.com> - 0.5-4.20170523git1f38ac
- Move to the latest upstream commit
- Disable non-working tests
- Enable python3 subpackage

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Jan 12 2017 Alfredo Moralejo <amoralej@redhat.com> 0.5-2
- Some fixes applied to spec.

* Thu Jan 12 2017 Alfredo Moralejo <amoralej@redhat.com> 0.5-1
- Initial spec
